#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// Make a USF file
// both ROM and RAM in reserved area, ROM first

int main(int argc, char ** argv) {
	FILE * inrom, * inram, * out;
	unsigned long romlen,ramlen,totlen, zero=0;
	char * buffer[4];

	if (argc != 4) {
		printf("usage: %s ROM RAM USF",argv[0]);
		return 0;
	}
	
	// open files
	out=fopen(argv[3],"wb");
	if (out < 0) {
		printf("error opening output");
		return 0;
	}
	if (!strcmp(argv[1],"NULL")) inrom=NULL;
	else {
		inrom=fopen(argv[1],"rb");
		if (!inrom) {
			printf("error opening input ROM");
			return 0;
		}
	}
	if (!strcmp(argv[2],"NULL")) inram=NULL;
	else {
		inram=fopen(argv[2],"rb");
		if (!inram) {
			printf("error opening input RAM");
			return 0;
		}
	}
	
	// get lengths
	if (inrom) {
		fseek(inrom,0,SEEK_END);
		romlen=ftell(inrom);
		fseek(inrom,0,SEEK_SET);
	} else romlen=4;
	if (inram) {
		fseek(inram,0,SEEK_END);
		ramlen=ftell(inram);
		fseek(inram,0,SEEK_SET);
	} else ramlen=4;

	// *** Write header

	// ASCII signature & version
	fprintf(out,"PSF!"); // '!'=0x21, USF

	// reserved area length (ROM+RAM)
	totlen=romlen+ramlen;
	fwrite(&totlen,4,1,out);

	// program length
	fwrite(&zero,4,1,out);

	// program CRC
	fwrite(&zero,4,1,out);

	// *** Write files
	if (inrom) {
		fread(buffer,1,1,inrom);
		while (!feof(inrom)) {
			fwrite(buffer,1,1,out);
			fread(buffer,1,1,inrom);
		}
		fclose(inrom);
	} else fwrite(&zero,4,1,out);
	if (inram) {
		fread(buffer,1,1,inram);
		while (!feof(inram)) {
			fwrite(buffer,1,1,out);
			fread(buffer,1,1,inram);
		}
		fclose(inram);
	} else fwrite(&zero,4,1,out);

	fclose(out);

	return 0;
}